use std::fs;

fn first_puzzle(input: &String) {
    let mut position = [0; 2];
    for line in input.lines() {
        if line.contains("forward") {
            // Surely there is a better way to parse a string for an integer ?
            position[0] += line.rsplit(' ').next().unwrap().parse::<i32>().unwrap();
        } else if line.contains("up") {
            position[1] -= line.rsplit(' ').next().unwrap().parse::<i32>().unwrap();
        } else if line.contains("down") {
            position[1] += line.rsplit(' ').next().unwrap().parse::<i32>().unwrap();
        }
    }

    println!("Position : {}, {}", position[0], position[1]);
    println!("Multiplied : {}", position[0] * position[1]);
}

fn second_puzzle(input: &String) {
    let mut position = [0; 3];
    for line in input.lines() {
        if line.contains("forward") {
            let forward_move = line.rsplit(' ').next().unwrap().parse::<i32>().unwrap();
            position[0] += forward_move;
            position[1] += forward_move * position[2];
        } else if line.contains("up") {
            position[2] -= line.rsplit(' ').next().unwrap().parse::<i32>().unwrap();
        } else if line.contains("down") {
            position[2] += line.rsplit(' ').next().unwrap().parse::<i32>().unwrap();
        }
    }

    println!("Position : {}, {}", position[0], position[1]);
    println!("Multiplied : {}", position[0] * position[1]);
}

fn main() {
    let contents = fs::read_to_string("../input.txt").expect("Could not open file.");
    first_puzzle(&contents);
    second_puzzle(&contents);
    0;
}
